Index: trunk/MagicSoft/Cosy/tpoint/tpoint0508.txt
===================================================================
--- trunk/MagicSoft/Cosy/tpoint/tpoint0508.txt	(revision 7295)
+++ trunk/MagicSoft/Cosy/tpoint/tpoint0508.txt	(revision 7312)
@@ -2,8 +2,8 @@
 : ALTAZ
 # --- 15.08.2005 --- 21:35:15.119
-33.9795 77.5505 176.5472 68.54409 18.61556 38.78361 -0.03091144 -0.2507075 53597.899481 225.7 2.56
+##33.9795 77.5505 176.5472 68.54409 18.61556 38.78361 -0.03091144 -0.2507075 53597.899481 225.7 2.56
 -108.7127 10.03228 33.79277 1.147275 13.42 -11.16139 -0.0406908 -0.01428905 53597.908022 220.4 2.658
 47.97229 59.85954 190.4619 50.86673 20.69056 45.28028 -0.01694123 -0.02132084 53597.921748 220.4 2.628
--4.915081 79.95781 137.5439 71.09162 18.61556 38.78361 -0.02097758 -0.2129085 53597.927261 211.8 2.557
+##-4.915081 79.95781 137.5439 71.09162 18.61556 38.78361 -0.02097758 -0.2129085 53597.927261 211.8 2.557
 -16.89718 35.7812 125.6257 26.92733 14.845 74.15556 -0.009626902 -0.01678521 53597.932514 231.1 2.822
 147.3607 67.03003 289.8065 58.03688 19.84639 8.868333 -0.01896161 -0.0433607 53597.941474 235.1 2.568
@@ -26,5 +26,5 @@
 9.832451 84.73775 151.8624 75.7146 20.77028 33.97028 -0.04940483 -0.08909074 53598.01085 224.3 3.13
 4.772805 84.80441 146.7648 75.77874 20.77028 33.97028 -0.05175183 -0.04703533 53598.012433 220.7 3.119
--68.57145 1.351099 73.95366 -7.581284 14.26111 19.1825 -0.08636231 -0.02134706 53598.020109 220.6 2.646
+##-68.57145 1.351099 73.95366 -7.581284 14.26111 19.1825 -0.08636231 -0.02134706 53598.020109 220.6 2.646
 -38.51547 9.943513 103.9937 1.079812 13.79222 49.31306 -0.02133257 0.001326446 53598.028158 240 2.832
 -17.48543 25.62058 125.0345 16.74052 14.845 74.15556 -0.03599472 -0.007225984 53598.037776 199.7 2.614
@@ -40,5 +40,5 @@
 70.96744 57.10539 213.4659 48.09993 20.77028 33.97028 -0.03036569 -0.02570286 53598.905033 218.4 3.045
 71.93045 29.08186 214.4645 20.12477 23.06278 28.08278 0.02130765 -0.02040737 53598.911409 231.3 2.772
-110.331 31.9986 252.9689 23.0386 22.09639 -0.3197222 0.01434053 -0.1364566 53598.920554 231.9 3.077
+##110.331 31.9986 252.9689 23.0386 22.09639 -0.3197222 0.01434053 -0.1364566 53598.920554 231.9 3.077
 138.3485 64.67669 280.819 55.70133 19.84639 8.868333 -0.001565069 -0.05261887 53598.926526 226.2 2.568
 -129.5906 66.45151 12.8354 57.56313 17.58222 12.56 -0.04558826 -0.03385056 53598.929789 216.5 2.81
@@ -70,6 +70,6 @@
 26.80519 78.61627 169.1931 69.60691 18.61556 38.78361 -0.0351461 -0.0884317 53599.9006 233 2.666
 16.71615 79.53886 159.078 70.49642 18.61556 38.78361 -0.06951019 -0.09812856 53599.908105 223.4 2.561
-6.638864 79.94627 149.0285 70.92197 18.61556 38.78361 -0.05042709 -0.1279688 53599.914671 223.9 2.558
-0.4217139 80.02596 142.8202 71.00037 18.61556 38.78361 -0.05184509 -0.1336573 53599.918538 223.5 2.564
+##6.638864 79.94627 149.0285 70.92197 18.61556 38.78361 -0.05042709 -0.1279688 53599.914671 223.9 2.558
+##0.4217139 80.02596 142.8202 71.00037 18.61556 38.78361 -0.05184509 -0.1336573 53599.918538 223.5 2.564
 139.0122 64.8971 281.4639 55.89917 19.84639 8.868333 -0.02221223 -0.03815141 53599.924752 233 2.562
 148.6186 67.31074 291.0395 58.29247 19.84639 8.868333 -0.04440334 -0.01929916 53599.937536 240 2.563
@@ -95,2 +95,86 @@
 89.20218 54.52621 231.6969 45.52651 2.119444 23.4625 -0.02133801 -0.02250085 53600.121934 240 2.733
 -52.60661 50.16564 89.89889 41.29703 20.69056 45.28028 -0.02314338 -0.03071057 53600.133557 215.6 2.619
+
+# --- 21.08.2005 --- 23:52:06.977
+-70.11431 3.887062 72.39401 -5.012958 14.26111 19.1825 -0.05780152 -0.00662231 53603.994525 226 2.634
+-69.56308 2.930872 72.95119 -5.964293 14.26111 19.1825 -0.04991301 -0.01415456 53603.997857 220.4 2.768
+-62.44221 55.475 80.03904 46.62828 18.61556 38.78361 -0.002937496 -0.02190933 53604.019171 212.2 3.091
+
+# --- 23.08.2005 --- 00:40:40.094
+-44.17754 39.84557 98.34079 30.98499 17.50722 52.30139 -0.01789289 -0.02498984 53605.028242 229.5 2.93
+179.456 45.14703 321.9345 36.17757 21.78389 -16.12722 0.004268668 -0.01649633 53605.035896 228.1 3.229
+-171.9959 71.03767 330.4066 62.14332 21.73639 9.875 -0.05656528 -0.04630211 53605.042328 225.3 2.913
+-166.3697 70.71427 336.036 61.82044 21.73639 9.875 -0.04783288 -0.04779581 53605.047601 222.4 2.942
+-110.0691 50.98888 32.40553 42.12595 19.77111 10.61333 -0.01796632 -0.02025938 53605.055842 233.3 3.133
+-95.13077 38.73641 47.34918 29.88378 19.09028 13.86333 -0.00785301 -0.002346236 53605.07233 216 3.339
+-158.9329 59.25593 343.5209 50.3878 22.09639 -0.3197222 -0.02317719 -0.02940316 53605.07934 225.9 3.172
+47.22569 36.54395 189.7476 27.57011 3.405278 49.86111 0.003862221 -0.01007162 53605.086996 226.7 2.778
+47.2862 19.15062 189.8253 10.21207 5.278056 45.99806 0.0391389 -0.01657546 53605.094364 237.2 2.561
+79.92895 16.68103 222.4622 7.706874 4.598611 16.50917 0.006277146 -0.01605437 53605.099187 230.2 2.585
+11.01569 58.63599 153.4992 49.66254 0.1530556 59.14972 -6.578275e-05 -0.01359514 53605.10435 223.9 2.947
+19.26495 59.51939 161.7677 50.53374 0.675 56.53722 -0.01046646 -0.02936271 53605.108016 237.1 2.905
+41.45173 45.22287 183.9823 36.26903 3.08 53.50639 0.02022193 -0.02871916 53605.113876 231.3 3.214
+-53.5409 40.4391 88.98408 31.57812 19.74944 45.13083 -0.02055866 -0.03577336 53605.119179 228.8 3.261
+-42.47982 22.80123 100.0514 13.93412 17.94333 51.48889 -0.02326705 -0.02487875 53605.123652 235.3 2.952
+-57.83617 25.035 84.69212 16.15443 18.61556 38.78361 -0.03785296 -0.02785815 53605.126382 233.5 2.558
+169.8528 42.69279 312.3443 33.72275 0.7263889 -17.98667 0.004275628 -0.02455182 53605.137592 240 2.689
+-53.35296 44.25231 89.15923 35.38773 20.69056 45.28028 -0.0182959 -0.02774603 53605.143282 224.5 2.63
+13.27064 56.99225 155.776 48.02061 1.430278 60.23528 0.002734975 -0.02754338 53605.147976 238.7 3.131
+59.0366 23.41183 201.5709 14.45069 5.995278 37.2125 0.01501561 -0.0153968 53605.153076 216.8 3.159
+93.4041 19.49395 235.9412 10.51097 5.418889 6.349722 -0.007019026 -0.02351572 53605.156733 238.3 2.795
+99.57054 14.5399 242.0911 5.571466 5.603611 -1.201944 0.008326225 -0.00775562 53605.160393 233 2.856
+77.00233 10.69161 219.5302 1.714783 6.628611 16.39917 -0.002260226 -0.005808991 53605.164277 240 3.123
+72.95935 33.38858 215.4917 24.408 5.438056 28.6075 -0.004973464 -0.02101346 53605.173658 235.7 2.703
+70.28579 17.23625 212.8124 8.267416 6.732222 25.13111 0.005979816 -0.006256862 53605.177771 224.9 3.331
+113.0522 21.62279 255.5725 12.63683 5.242222 -8.201667 -0.007327684 -0.01535205 53605.181143 240 2.56
+98.68625 28.27103 241.2105 19.28479 5.418889 6.349722 -0.008741415 -0.01782004 53605.184675 232.7 2.734
+95.14457 45.04963 237.6648 36.04729 4.598611 16.50917 -0.02626917 -0.02858902 53605.189207 231.5 2.583
+-64.92485 29.20645 77.58197 20.35441 20.77028 33.97028 -0.006644661 -0.01114689 53605.195661 227.7 3.076
+-82.53287 5.061837 59.96916 -3.817096 19.84639 8.868333 -0.0388709 -0.005771509 53605.203819 238.7 3.079
+63.37048 19.04342 205.8909 10.05826 7.576667 31.88833 -0.009205324 0.0005979467 53605.209798 229.6 2.777
+129.0131 20.06679 271.5321 11.06028 5.470833 -20.75944 -0.03219855 -0.01815316 53605.214156 234.7 3.263
+-16.06606 55.69341 126.4215 46.83566 0.945 60.71667 -0.0132912 -0.01091033 53605.219898 224.9 2.855
+
+# --- 23.08.2005 --- 23:17:33.638
+49.73044 81.58766 191.9569 72.58531 20.77028 33.97028 -0.02954768 -0.05364637 53605.970528 213.3 3.168
+37.67953 83.30265 179.887 74.29249 20.77028 33.97028 -0.03595603 -0.1344505 53605.978278 210.6 3.195
+30.18398 83.93026 172.2781 74.91418 20.77028 33.97028 -0.04208625 -0.07820253 53605.981779 224.7 3.162
+18.62913 84.50437 160.6941 75.48728 20.77028 33.97028 -0.04247662 -0.09030945 53605.986128 224 3.156
+9.705247 84.72368 151.8155 75.71467 20.77028 33.97028 -0.0349424 -0.1616896 53605.989023 216.4 3.193
+2.892551 84.79652 144.8541 75.79077 20.77028 33.97028 -0.03207221 -0.04754372 53605.991164 213.5 3.173
+-19.9367 84.45685 122.1402 75.57694 20.77028 33.97028 -0.03551407 -0.09344246 53605.998381 222.2 3.166
+-30.37324 83.93039 111.7683 75.0441 20.77028 33.97028 -0.04100266 -0.1292487 53606.002334 219.2 3.18
+-40.17357 83.05994 101.9663 74.17695 20.77028 33.97028 -0.03640417 -0.07090228 53606.007065 226.6 3.156
+
+# --- 24.08.2005 --- 01:42:19.438
+95.63148 84.83363 237.6417 75.81226 23.06278 28.08278 -0.04394831 -0.1081348 53606.071058 223.7 2.9
+104.849 87.66268 246.2594 78.64209 23.06278 28.08278 -0.04495052 -0.3190598 53606.080127 206.1 2.895
+114.9966 88.56704 255.5392 79.52975 23.06278 28.08278 -0.06254684 -0.3276417 53606.083104 221.3 2.91
+130.5802 89.05696 269.7032 80.03489 23.06278 28.08278 -0.04600091 -0.1753274 53606.084998 216 2.912
+151.4471 89.32184 288.9971 80.28781 23.06278 28.08278 -0.05870579 -0.08094357 53606.086248 222.1 2.914
+161.8803 89.35793 299.7242 80.34576 23.06278 28.08278 -0.03738417 -0.6555016 53606.086711 215.8 2.898
+163.6731 89.36407 301.0457 80.35055 23.06278 28.08278 -0.03805907 -0.4174269 53606.086771 214.9 2.896
+170.8408 89.39057 308.8955 80.37092 23.06278 28.08278 -0.04531978 -1.103237 53606.087063 228.1 2.895
+-121.2917 88.79779 18.18017 79.92512 23.06278 28.08278 -0.031293 0.1311272 53606.090658 221.6 2.902
+-112.6175 88.38288 27.57605 79.51355 23.06278 28.08278 -0.02953879 0.156851 53606.092121 221.5 2.902
+-103.036 87.27255 38.36263 78.4079 23.06278 28.08278 -0.02274183 -0.1285554 53606.095774 213.3 2.923
+-92.98912 82.61974 49.06547 73.75633 23.06278 28.08278 -0.0221741 0.02493934 53606.110593 224.7 2.903
+-91.67507 80.91965 50.57006 72.04607 23.06278 28.08278 -0.02929102 -0.07338063 53606.115994 216.1 2.922
+82.02857 87.03522 223.7225 78.02306 0.1397222 29.09056 -0.03993937 -0.2655009 53606.122666 225.1 2.795
+71.40509 88.85515 211.5423 79.84654 0.1397222 29.09056 -0.03109191 -0.4548484 53606.128568 228.4 2.815
+##*59.98624 89.26676 199.779 80.26118 0.1397222 29.09056 -0.02828065 -1.608612 53606.129987 220.2 2.842
+##*49.16094 89.45102 187.9282 80.4476 0.1397222 29.09056 -0.0264997 -1.979763 53606.130691 226.7 2.83
+##*38.58774 89.54807 176.9566 80.54553 0.1397222 29.09056 -0.02898614 -2.840532 53606.131103 219.9 2.815
+##*27.05934 89.608 164.343 80.60961 0.1397222 29.09056 -0.0230108 -2.695173 53606.131459 226.2 2.807
+##*18.48464 89.6398 154.0605 80.64117 0.1397222 29.09056 -0.02359133 -1.7188 53606.131692 224.4 2.813
+##*7.06407 89.70317 142.6589 80.73923 0.1397222 29.09056 -0.06803369 -2.191836 53606.131926 220 2.919
+##*-1.52248 89.78481 133.9971 80.7929 0.1397222 29.09056 -0.1449181 -1.988184 53606.132103 225.2 2.841
+
+-70.9905 88.95418 69.08482 80.07318 0.1397222 29.09056 -0.0393356 -0.6531291 53606.135354 219.2 2.819
+-80.35903 87.83797 60.95691 78.94047 0.1397222 29.09056 -0.05321397 -0.3171041 53606.139033 217.9 2.857
+-84.43938 85.18967 57.44097 76.32055 0.1397222 29.09056 -0.0288866 -0.0387353 53606.147394 216.6 2.818
+-151.9463 74.90341 350.3913 66.01864 0.2205556 15.18361 -0.04002731 -0.03006618 53606.155751 221.5 3.045
+-142.228 73.3762 0.1242493 64.50633 0.2205556 15.18361 -0.02639855 -0.02675721 53606.164526 220.1 3.048
+-132.0098 70.9009 10.3901 62.02838 0.2205556 15.18361 -0.02930558 -0.04598286 53606.175999 215.6 3.031
+-167.0579 42.31837 335.4432 33.45653 0.7263889 -17.98667 -0.01660967 -0.03691953 53606.184352 234.8 2.789
+-158.024 40.35643 344.4685 31.50261 0.7263889 -17.98667 -0.009747074 -0.02461631 53606.204881 233.7 2.818